"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var _this = this;
Object.defineProperty(exports, "__esModule", { value: true });
var commander = require("commander");
var main_1 = require("../main");
var glob_1 = require("../utils/glob");
var exclude_1 = require("./exclude");
var version_1 = require("./version");
var defaultMember = function (member, defaultValue) {
    return member === undefined ? defaultValue : member;
};
exports.cli = function (dependencies) { return __awaiter(_this, void 0, void 0, function () {
    var argv, globber, logger, mainExecutor, command, _a, includes, excludes, files, _i, excludes_1, exclude;
    return __generator(this, function (_b) {
        switch (_b.label) {
            case 0:
                argv = dependencies.argv;
                globber = defaultMember(dependencies.globber, glob_1.globAllAsync);
                logger = defaultMember(dependencies.logger, console);
                mainExecutor = defaultMember(dependencies.main, main_1.main);
                command = new commander.Command()
                    .usage("[options] <file ...> --language [language]")
                    .option("-e, --exclude [exclude]", "file glob(s) to exclude")
                    .option("-l, --language [language]", "language to convert to")
                    .option("-t, --tsconfig [tsconfig]", "(TypeScript only) configuration project")
                    .option("-v, --version", "output the CLI and GLS version numbers")
                    .on("--help", function () {
                    logger.log();
                    logger.log("  Basic GLS conversion:");
                    logger.log();
                    logger.log("    $ gls --language Python file.gls");
                    logger.log();
                    logger.log("  Converting a TypeScript project to GLS, then to Java:");
                    logger.log();
                    logger.log("    $ gls --language Java --tsconfig ./tsconfig ./src/*.ts");
                    logger.log();
                })
                    .parse(argv);
                if (!command.hasOwnProperty("version")) return [3 /*break*/, 2];
                return [4 /*yield*/, version_1.printCliVersions(logger)];
            case 1:
                _b.sent();
                return [2 /*return*/, main_1.ExitCode.Ok];
            case 2:
                if (command.args.length === 0) {
                    command.help();
                    return [2 /*return*/, main_1.ExitCode.Ok];
                }
                return [4 /*yield*/, Promise.all([
                        globber(command.args),
                        exclude_1.getExcludes(command.exclude, globber),
                    ])];
            case 3:
                _a = _b.sent(), includes = _a[0], excludes = _a[1];
                files = new Set(includes);
                for (_i = 0, excludes_1 = excludes; _i < excludes_1.length; _i++) {
                    exclude = excludes_1[_i];
                    files.delete(exclude);
                }
                return [2 /*return*/, mainExecutor({
                        files: files,
                        languageName: command.language,
                        logger: console,
                        typescriptConfig: command.tsconfig,
                    })];
        }
    });
}); };
//# sourceMappingURL=cli.js.map