import { IConverterDependencies } from "../../coordinator";
import { IRunOptions } from "../../runner";
import { TypeScriptConverter } from "./converter";
/**
 * Asynchronously creates a converter.
 *
 * @param dependencies   Dependencies to create the converter.
 * @param options   Options for converting files.
 * @returns A Promise for a converter or error string.
 */
export declare const createTypeScriptConverter: (dependencies: IConverterDependencies, options: IRunOptions) => Promise<TypeScriptConverter | "No TypeScript configuration file provided (--tsconfig).">;
