"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var gls_1 = require("./converters/gls");
var typescript_1 = require("./converters/typescript");
var coordinator_1 = require("./coordinator");
exports.createCoordinator = function (dependencies) {
    return new coordinator_1.Coordinator({
        converter: new gls_1.GlsConverter({
            fileSystem: dependencies.fileSystem,
            language: dependencies.language,
        }),
        fileSystem: dependencies.fileSystem,
        logger: console,
        preprocessors: new Map([
            [typescript_1.tsExtension, typescript_1.createTypeScriptConverter],
        ]),
    });
};
//# sourceMappingURL=coordinatorFactory.js.map