import { ILogger } from "./logger";
export declare enum ExitCode {
    Ok = 0,
    Error = 1
}
export interface IMainDependencies {
    /**
     * Unique file paths to convert.
     */
    files: Set<string>;
    /**
     * Name of the GLS language to convert to.
     */
    languageName?: string;
    /**
     * Logs information on significant events.
     */
    logger: ILogger;
    /**
     * TypeScript configuration project, if provided.
     */
    typescriptConfig?: string;
}
export declare type IMain = (dependencies: IMainDependencies) => Promise<number>;
export declare const main: IMain;
