"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var _this = this;
Object.defineProperty(exports, "__esModule", { value: true });
var chalk_1 = require("chalk");
var general_language_syntax_1 = require("general-language-syntax");
var files_1 = require("./files");
var runnerFactory_1 = require("./runnerFactory");
var ExitCode;
(function (ExitCode) {
    ExitCode[ExitCode["Ok"] = 0] = "Ok";
    ExitCode[ExitCode["Error"] = 1] = "Error";
})(ExitCode = exports.ExitCode || (exports.ExitCode = {}));
var createFileContentsMap = function (filePaths, fileSystem) { return __awaiter(_this, void 0, void 0, function () {
    var map, _i, _a, filePath, _b, _c, _d;
    return __generator(this, function (_e) {
        switch (_e.label) {
            case 0:
                map = new Map();
                _i = 0, _a = Array.from(filePaths);
                _e.label = 1;
            case 1:
                if (!(_i < _a.length)) return [3 /*break*/, 4];
                filePath = _a[_i];
                _c = (_b = map).set;
                _d = [filePath];
                return [4 /*yield*/, fileSystem.readFile(filePath)];
            case 2:
                _c.apply(_b, _d.concat([_e.sent()]));
                _e.label = 3;
            case 3:
                _i++;
                return [3 /*break*/, 1];
            case 4: return [2 /*return*/, map];
        }
    });
}); };
exports.main = function (dependencies) { return __awaiter(_this, void 0, void 0, function () {
    var printAvailableLanguages, getLanguageFromName, run, error_1;
    var _this = this;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                printAvailableLanguages = function (languageNames) {
                    dependencies.logger.log("Available languages:");
                    for (var _i = 0, languageNames_1 = languageNames; _i < languageNames_1.length; _i++) {
                        var languageName = languageNames_1[_i];
                        dependencies.logger.log("\t" + languageName);
                    }
                };
                getLanguageFromName = function (languageName) {
                    var languagesBag = new general_language_syntax_1.LanguagesBag();
                    var languageNames = languagesBag.getLanguageNames();
                    if (languageName === undefined) {
                        dependencies.logger.error("You must provide a -l/--language.");
                        printAvailableLanguages(languageNames);
                        return undefined;
                    }
                    if (languageNames.indexOf(languageName) === -1) {
                        dependencies.logger.error("Unknown language name: '" + chalk_1.default.bold(languageName) + "'.");
                        printAvailableLanguages(languageNames);
                        return undefined;
                    }
                    return languagesBag.getLanguageByName(languageName);
                };
                run = function () { return __awaiter(_this, void 0, void 0, function () {
                    var language, fileSystem, runner, _a, _b, _c;
                    return __generator(this, function (_d) {
                        switch (_d.label) {
                            case 0:
                                language = getLanguageFromName(dependencies.languageName);
                                if (language === undefined) {
                                    return [2 /*return*/, ExitCode.Error];
                                }
                                fileSystem = new files_1.FileSystem();
                                runner = runnerFactory_1.createRunner({
                                    fileSystem: fileSystem,
                                    language: language,
                                    logger: dependencies.logger,
                                });
                                _b = (_a = runner).run;
                                _c = {};
                                return [4 /*yield*/, createFileContentsMap(dependencies.files, fileSystem)];
                            case 1: return [4 /*yield*/, _b.apply(_a, [(_c.files = _d.sent(),
                                        _c.typescriptConfig = dependencies.typescriptConfig,
                                        _c)])];
                            case 2:
                                _d.sent();
                                return [2 /*return*/, ExitCode.Ok];
                        }
                    });
                }); };
                _a.label = 1;
            case 1:
                _a.trys.push([1, 3, , 4]);
                return [4 /*yield*/, run()];
            case 2: return [2 /*return*/, _a.sent()];
            case 3:
                error_1 = _a.sent();
                dependencies.logger.error(error_1.message);
                return [2 /*return*/, ExitCode.Error];
            case 4: return [2 /*return*/];
        }
    });
}); };
//# sourceMappingURL=main.js.map