/**
 * Retrieves a file's extension.
 *
 * @param filePath   Original file path.
 * @returns Extension from the file, including preceding period.
 */
export declare const getFileExtension: (filePath: string) => string;
/**
 * Replaces a file's extension.
 *
 * @param filePath   Original file path.
 * @param oldExtension   Original file extension.
 * @param newExtension   Extension to replace the old extension.
 * @returns The file's equivalent with the new extension.
 */
export declare const replaceFileExtension: (filePath: string, oldExtension: string, newExtension: string) => string;
