"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * Retrieves a file's extension.
 *
 * @param filePath   Original file path.
 * @returns Extension from the file, including preceding period.
 */
exports.getFileExtension = function (filePath) {
    return filePath.substring(filePath.lastIndexOf("."));
};
/**
 * Replaces a file's extension.
 *
 * @param filePath   Original file path.
 * @param oldExtension   Original file extension.
 * @param newExtension   Extension to replace the old extension.
 * @returns The file's equivalent with the new extension.
 */
exports.replaceFileExtension = function (filePath, oldExtension, newExtension) {
    return filePath.substring(filePath.length - oldExtension.length) === oldExtension
        ? "" + filePath.substring(0, filePath.length - oldExtension.length) + newExtension
        : "" + filePath + newExtension;
};
//# sourceMappingURL=extensions.js.map